//
// Copyright 2007 Johannes Hofmann <Johannes.Hofmann@gmx.de>
//
// This software may be used and distributed according to the terms
// of the GNU General Public License, incorporated herein by reference.

#ifndef CoordinateTransform_H
#define CoordinateTransform_H

#include "ImageInfo.H"

class CoordinateTransform {
	public:
		typedef enum {
			TO_ORIGINAL = 0,
			TO_LOCAL = 1} dir_t;
		double shift_x, shift_y;
		double scale_x, scale_y;

		CoordinateTransform();
		void reset();
		void copy(CoordinateTransform *c);
		void combine(CoordinateTransform *c);
		double transform_x(double _v, dir_t d);
		double transform_y(double _v, dir_t d);
		double transform_scale_x(double _v, dir_t d);
		double transform_scale_y(double _v, dir_t d);
		int convert(CoordinateTransform *loc_trans, ImageInfo *img_info,
			const char *str, char *buf, int buflen, dir_t d, int strip);
	private:
		int convert_rec(CoordinateTransform *loc_trans, ImageInfo *img_info,
			const char *str, char *buf, int buflen, dir_t d, int strip);
};

#endif
