//
// Copyright 2008 Johannes Hofmann <Johannes.Hofmann@gmx.de>
//
// This software may be used and distributed according to the terms
// of the GNU General Public License, incorporated herein by reference.

#ifndef ExternalGui_H
#define ExternalGui_H

#include <stdio.h>

#include <FL/Fl_Button.H>

#include "FlimpText.H"

class ExternalGui : public FlimpText {
	private:
		Fl_Button *gui_b;
		char *gui_cmd;
		pid_t cmd_pid;
		FILE *cmd_infp, *cmd_outfp;

		static void button_cb(Fl_Widget *w, void *d);
		static void read_cb(int fd, void *d);

	public:
		ExternalGui(int _x, int _y, int _w, int _h, const char *n = NULL);
		virtual ~ExternalGui();

		virtual void set_gui_data(const char *d);
		virtual const char *get_gui() {return "ExternalGui";};
		virtual const char *get_gui_data() {return gui_cmd;};
		virtual void set_command(const char *c);
};

#endif
