//
// Copyright 2007 Johannes Hofmann <Johannes.Hofmann@gmx.de>
//
// This software may be used and distributed according to the terms
// of the GNU General Public License, incorporated herein by reference.

#ifndef FlimpSelect_H
#define FlimpSelect_H

#include <FL/Fl_Button.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Group.H> // necessary in older fltk versions
#include <FL/Fl_Input_Choice.H>

#include "FlimpWidget.H"
#include "SelectImage.H"

class FlimpSelect : public FlimpWidget {
	private:
		Fl_Choice *ratio_c;
		Fl_Button *sel_b;
		Fl_Input_Choice *choice;
		SelectImage::SelectType type;
		char buf[1024];
		char *command_format;
		enum {ORIGINAL = 0, SELECTED = 1} state;
		double orig_x, orig_y, orig_w, orig_h;
		double local_x, local_y, local_w, local_h;

		static void ratio_cb(Fl_Widget *w, void *d);
		static void button_cb(Fl_Widget *w, void *d);
		static void cmd_cb(Fl_Widget *w, void *d);
		void to_local();
		void to_orig();
		void select();
		void original();
		void execute();

	public:
		FlimpSelect(int _x, int _y, int _w, int _h,
			SelectImage::SelectType t, const char *n = NULL);
		virtual const char *get_gui();
		virtual const char *get_gui_data() {return command_format;};
		virtual void set_gui_data(const char *d);
		virtual void set_command(const char *c);
};

#endif
