//
// Copyright 2007 Johannes Hofmann <Johannes.Hofmann@gmx.de>
//
// This software may be used and distributed according to the terms
// of the GNU General Public License, incorporated herein by reference.

#include <stdio.h>
#include <string.h>

#include "FlimpText.H"

void
FlimpText::proc_cb(Fl_Widget* o, void* d) {
    FlimpText *f = (FlimpText*) d;

    f->set_local_command(f->choice->value());
	f->choice->input()->mark(f->choice->input()->position()); // deselect text
}

FlimpText::FlimpText(int _x, int _y, int _w, int _h, const char *n) :
	FlimpWidget(_x, _y, _w, _h, n) {

	choice = new Fl_Input_Choice(0, 0, 400, 0);
	choice->callback((Fl_Callback*) proc_cb, this);
	Fl_Input *text = choice->input();
	text->color(FL_GRAY);
	text->when(FL_WHEN_ENTER_KEY_ALWAYS);
	add_control(choice);
}

void
FlimpText::set_command(const char *c) {
	char buf[2048];
	unsigned int j = 0;

	// escape '&', '/', '\', and '_'
	for (int i = 0; c[i] && j < sizeof(buf) - 1; i++) {
		if (strchr("&/\\_", c[i]))
			buf[j++] = '\\';
		buf[j++] = c[i];
	}
	buf[j] = '\0';

	choice->value(c);
	choice->add(buf);
}
