//
// Copyright 2007 Johannes Hofmann <Johannes.Hofmann@gmx.de>
//
// This software may be used and distributed according to the terms
// of the GNU General Public License, incorporated herein by reference.

#ifndef Rectangle_H
#define Rectangle_H

class Rectangle {
	int X, Y, W, H;

	public:
		Rectangle(int _x, int _y, int _w, int _h) {
			X = _x;
			Y = _y;
			W = _w;
			H = _h;
		};

		int x() const {return X;};
		int y() const {return Y;};
		int w() const {return W;};
		int h() const {return H;};

		void intersect(const Rectangle *r) {
			if (r->x() + r->w() < X + W)
				W = r->x() + r->w() - X;
			if (r->x() > X) {
				W -= r->x() - X;
				X = r->x();
			}

			if (r->y() + r->h() < Y + H)
				H = r->y() + r->h() - Y;
			if (r->y() > Y) {
				H -= r->y() - Y;
				Y = r->y();
			}

			if (W < 0) W = 0;
			if (H < 0) H = 0;
		};
};

#endif
