//
// Copyright 2007 Johannes Hofmann <Johannes.Hofmann@gmx.de>
//
// This software may be used and distributed according to the terms
// of the GNU General Public License, incorporated herein by reference.

#ifndef SelectImage_H
#define SelectImage_H

#include <FL/Fl_Widget.H>
#include <FL/Fl_Shared_Image.H>

class SelectImage : public Fl_Widget {
	public:
		typedef enum {
			NONE = 0,
			POINT = 1,
			RECTANGLE = 2,
		} SelectType;

		double ratio;
		Fl_Shared_Image *img;

		SelectImage(int _x, int _y, int _w, int _h);
		~SelectImage();
		void draw();
		int handle(int e);
		int load(const char *p);
		int reload();
		void set_type(SelectType s) {type = s;};
		SelectType get_type() {return type;};
		void set_rectangle(double _x, double _y, double _w, double _h);
		void get_rectangle(double *_x, double *_y, double *_w, double *_h);
		void set_point(double _x, double _y);
		void get_point(double *_x, double *_y);

	private:
		int sel_x, sel_y, sel_w, sel_h;
		SelectImage::SelectType type;
};

#endif
